Loading...
Searching...
No Matches
pcl::RandomSample< pcl::PCLPointCloud2 > Class Reference
Module filters

RandomSample applies a random sampling with uniform probability. More...

`#include <pcl/filters/random_sample.h>`

Inheritance diagram for pcl::RandomSample< pcl::PCLPointCloud2 >:

## Public Types

using | Ptr = shared_ptr<RandomSample<pcl::PCLPointCloud2> >
using | ConstPtr = shared_ptr<const RandomSample<pcl::PCLPointCloud2> >
Public Types inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
using | PCLPointCloud2 = pcl::PCLPointCloud2
using | PointCloud
using | Ptr
using | ConstPtr
Public Types inherited from pcl::Filter< pcl::PCLPointCloud2 >
using | Ptr = shared_ptr<Filter<pcl::PCLPointCloud2> >
using | ConstPtr = shared_ptr<const Filter<pcl::PCLPointCloud2> >
using | PCLPointCloud2 = pcl::PCLPointCloud2
using | PCLPointCloud2Ptr = PCLPointCloud2::Ptr
using | PCLPointCloud2ConstPtr = PCLPointCloud2::ConstPtr
using | PointCloud
using | PointCloudPtr
using | PointCloudConstPtr
Public Types inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
using | PCLPointCloud2 = pcl::PCLPointCloud2
using | PCLPointCloud2Ptr = PCLPointCloud2::Ptr
using | PCLPointCloud2ConstPtr = PCLPointCloud2::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr
using | PointCloud
using | PointCloudPtr
using | PointCloudConstPtr

## Public Member Functions

| RandomSample ()
| Empty constructor.
void | setSample (unsigned int sample)
| Set number of indices to be sampled.
unsigned int | getSample ()
| Get the value of the internal sample parameter.
void | setSeed (unsigned int seed)
| Set seed of random function.
unsigned int | getSeed ()
| Get the value of the internal seed parameter.
Public Member Functions inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
| FilterIndices (bool extract_removed_indices=false)
| Constructor.
void | filter (Indices &indices)
| Calls the filtering method and returns the filtered point cloud indices.
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions.
bool | getNegative () const
| Get whether the regular conditions for points filtering should apply, or the inverted conditions.
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
bool | getKeepOrganized () const
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them.
Public Member Functions inherited from pcl::Filter< pcl::PCLPointCloud2 >
| Filter (bool extract_removed_indices=false)
| Empty constructor.
IndicesConstPtr const | getRemovedIndices () const
| Get the point indices being removed.
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed.
void | filter (PCLPointCloud2 &output)
| Calls the filtering method and returns the filtered dataset in output.
Public Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
| PCLBase ()
| Empty constructor.
virtual | ~PCLBase ()=default
| destructor.
void | setInputCloud (const PCLPointCloud2ConstPtr &cloud)
| Provide a pointer to the input dataset.
PCLPointCloud2ConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
IndicesPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const pcl::PCLPointCloud2 & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

void | applyFilter (PCLPointCloud2 &output) override
| Sample of point indices into a separate PointCloud.
void | applyFilter (Indices &indices) override
| Sample of point indices.
float | unifRand ()
| Return a random number fast using a LCG (Linear Congruential Generator) algorithm.
Protected Member Functions inherited from pcl::Filter< pcl::PCLPointCloud2 >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
Protected Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
bool | initCompute ()
bool | deinitCompute ()

## Protected Attributes

unsigned int | sample_
| Number of indices that will be returned.
unsigned int | seed_
| Random number seed.
Protected Attributes inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
bool | negative_ {false}
| False = normal filter behavior (default), true = inverted behavior.
bool | keep_organized_ {false}
| False = remove points (default), true = redefine points, keep structure.
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN).
Protected Attributes inherited from pcl::Filter< pcl::PCLPointCloud2 >
IndicesPtr | removed_indices_
| Indices of the points that are removed.
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points.
std::string | filter_name_
| The filter name.
Protected Attributes inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
PCLPointCloud2ConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.
std::vector< uindex_t > | field_sizes_
| The size of each individual field.
index_t | x_idx_
| The x-y-z fields indices.
index_t | y_idx_
index_t | z_idx_
std::string | x_field_name_
| The desired x-y-z field names.
std::string | y_field_name_
std::string | z_field_name_

## Detailed Description

RandomSample applies a random sampling with uniform probability.

Author
  Justin Rosen

Definition at line 148 of file random_sample.h.

## Member Typedef Documentation

## ConstPtr

using pcl::RandomSample< pcl::PCLPointCloud2 >::ConstPtr = shared_ptr<const RandomSample<pcl::PCLPointCloud2> >

Definition at line 160 of file random_sample.h.

## Ptr

using pcl::RandomSample< pcl::PCLPointCloud2 >::Ptr = shared_ptr<RandomSample<pcl::PCLPointCloud2> >

Definition at line 159 of file random_sample.h.

## Constructor & Destructor Documentation

## RandomSample()

pcl::RandomSample< pcl::PCLPointCloud2 >::RandomSample | ( |  | ) |

inline

Empty constructor.

Definition at line 163 of file random_sample.h.

References pcl::Filter< pcl::PCLPointCloud2 >::filter_name_, sample_, and seed_.

## Member Function Documentation

## applyFilter() [1/2]

void pcl::RandomSample< pcl::PCLPointCloud2 >::applyFilter | ( | Indices & | indices | ) |

override protected virtual

Sample of point indices.

Parameters

  indices | the resultant point cloud indices

Implements pcl::FilterIndices< pcl::PCLPointCloud2 >.

## applyFilter() [2/2]

void pcl::RandomSample< pcl::PCLPointCloud2 >::applyFilter | ( | PCLPointCloud2 & | output | ) |

override protected virtual

Sample of point indices into a separate PointCloud.

Parameters

  output | the resultant point cloud

Implements pcl::FilterIndices< pcl::PCLPointCloud2 >.

## getSample()

unsigned int pcl::RandomSample< pcl::PCLPointCloud2 >::getSample | ( |  | ) |

inline

Get the value of the internal sample parameter.

Definition at line 182 of file random_sample.h.

References sample_.

## getSeed()

unsigned int pcl::RandomSample< pcl::PCLPointCloud2 >::getSeed | ( |  | ) |

inline

Get the value of the internal seed parameter.

Definition at line 199 of file random_sample.h.

References seed_.

## setSample()

void pcl::RandomSample< pcl::PCLPointCloud2 >::setSample | ( | unsigned int | sample | ) |

inline

Set number of indices to be sampled.

Parameters

  sample |

Definition at line 174 of file random_sample.h.

References sample_.

## setSeed()

void pcl::RandomSample< pcl::PCLPointCloud2 >::setSeed | ( | unsigned int | seed | ) |

inline

Set seed of random function.

Parameters

  seed |

Definition at line 191 of file random_sample.h.

References seed_.

## unifRand()

float pcl::RandomSample< pcl::PCLPointCloud2 >::unifRand | ( |  | ) |

inline protected

Return a random number fast using a LCG (Linear Congruential Generator) algorithm.

See http://software.intel.com/en-us/articles/fast-random-number-generator-on-the-intel-pentiumr-4-processor/ for more information.

Definition at line 227 of file random_sample.h.

## Member Data Documentation

## sample_

unsigned int pcl::RandomSample< pcl::PCLPointCloud2 >::sample_

protected

Number of indices that will be returned.

Definition at line 207 of file random_sample.h.

Referenced by getSample(), RandomSample(), and setSample().

## seed_

unsigned int pcl::RandomSample< pcl::PCLPointCloud2 >::seed_

protected

Random number seed.

Definition at line 209 of file random_sample.h.

Referenced by getSeed(), RandomSample(), and setSeed().

The documentation for this class was generated from the following files:

- pcl/filters/random_sample.h
- pcl/filters/impl/random_sample.hpp